longest continuous subsequence of 0s

Michal Forišek
Michal Forišekteacher, scientist, competitive programmer
15.4k Views  • Upvoted by  Alon AmitCS degree and many years of coding.
Michal is a Most Viewed Writer in  Big-O Notation.

This problem has a much faster solution than the one (probably) required in the question. For a given n it is solvable in only O(log log n) basic bitwise instructions. Below I'm using b-bit unsigned integers and I show how to find the longest contiguous sequence of 0 bits in O(log b) time. Basically, we will use a clever binary search.

First step: zeros at the end as a special case. On many modern processors this can be done in constant time by using a specialized instruction (http://en.wikipedia.org/wiki/Cou...), but even in its absence it is easy to find their count in O(log b) time.

After we count the trailing zeros, we change them to ones to get rid of them. Then we get to  general case. Let z be the input number, after we changed the trailing 0s to 1s.

Imagine the zeros as empty space, and ones as bushes:
example:
       z = .....11......1...1

Note that we have at least one bush at the right end.
The bushes will grow towards the left, one step at a time. We can grow the bushes by one step by computing z | z<<1:
example:     
       z = .....11......1...1
    z<<1 = ....11......1...1.
  z|z<<1 = ....111.....11..11

(The operator | is bitwise or, the operator << is left shift.)

We will use s(i) to denote the configuration obtained from z after i steps.
So far, we know that s(0)=z and that s(1) can be computed as z | z<<1.

At this point it should be obvious that the length of the longest sequence of consecutive 0s is equal to the number of steps it takes until the bushes cover everything. That is, we are looking for the smallest x such that s(x) has all 1s.
If s(0) or s(1) have this property, we are done.

Let's do one more step, now with z=s(1):
example:
       z = ....111.....11..11
    z<<1 = ...111.....11..11.
  z|z<<1 = ...1111....111.111


The bottom line shows the state s(2). Each gap is now 2 shorter than it was in the beginning.

Of course, now we could continue growing the bushes one step at a time and checking whether we are done after each step. This would give us a nice simple solution in O(b) steps. But we are smarter than that! We will speed up the growth of our bushes exponentially.

Note that currently each cluster of bushes has more than two of them. Thus, we can now simulate two more steps at once by computing z | z<<2:
example:
       z = ...1111....111.111
    z<<2 = .1111....111.111..
  z|z<<2 = .111111..111111111


The bottom line of the example above shows the configuration s(4). 
We can now use s(4) to compute s(8) as s(4) | s(4)<<4. Next, we use s(8) to compute s(16), and so on, until we get a state with all 1s. (Note that this must happen in at most log b iterations.)

What shall we do next?
Let's see it on an example. Suppose that s(8) still has some gaps but s(16) has none. This tells us that in the original configuration the length of the longest segment of 0s is between 9 and 16, inclusive. To find the exact length, we will now use binary search on the interval (8,16].

How to do the binary search?
Continuing our example, we now want to check whether there are some 0s present in s(12). How can we compute s(12)? This is easy: s(12) = s(8) | s(8)<<4.
From s(8) we can compute in constant time each of the configurations we might need during the binary search by using different shift amounts.

Thus, in our solution we use O(log b) instructions to find an interval of the form ( 2^i, 2^(i+1) ] that contains the answer, and then we use another O(log b) instructions to find the exact answer using binary search.

Sample implementation:  http://ideone.com/unp7hD
(update: simplified code according to a suggestion by  Obinna Okechukwu)
Benchmarks on my machine: ~6x faster than the O(b) version when iterating over all 32-bit unsigneds, ~9x faster than O(b) version for random 64-bit unsigneds.



In practice we can do even better, we just need to spend some memory. If we precompute the answers and also the number of leading/trailing zeros for 16-bit unsigneds, we can easily combine them into answers for longer numbers. For 32-bit integers this approach is more than 2x faster than the O(log b) version in my benchmarks
  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值